/**
 * Copyright (c) 2015-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * @flow
 */
'use strict';

var Highlighter = require('./Highlighter');

module.exports = function setup(agent) {
  var hl = new Highlighter(window, function (node) {
    agent.selectFromDOMNode(node);
  });
  agent.on('highlight', function (data) {
    return hl.highlight(data.node, data.name);
  });
  agent.on('highlightMany', function (nodes) {
    return hl.highlightMany(nodes);
  });
  agent.on('hideHighlight', function () {
    return hl.hideHighlight();
  });
  agent.on('startInspecting', function () {
    return hl.startInspecting();
  });
  agent.on('stopInspecting', function () {
    return hl.stopInspecting();
  });
  agent.on('shutdown', function () {
    hl.remove();
  });
};