/**
 * Copyright (c) 2015-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * @flow
 */
'use strict';

/* global chrome */

module.exports = function (scriptName, done) {
  var src = '\n  // the prototype stuff is in case document.createElement has been modified\n  var script = document.constructor.prototype.createElement.call(document, \'script\');\n  script.src = "' + scriptName + '";\n  document.documentElement.appendChild(script);\n  script.parentNode.removeChild(script);\n  ';

  chrome.devtools.inspectedWindow.eval(src, function (res, err) {
    if (err) {
      console.log(err);
    }
    done();
  });
};